 New features:
 -------------
 * action to be taken on middle mouse button press can now be configured
 * new "pipe" setting for output written to the parallel port,
   allowing to pass it eg. directly to lpr
 * NatFeat configuration support for EmuTOS


2019/04/14 - version 1.1.0 released
==========

 List of changes in this release is 60 pages long! No wonder as it's been
 four and half years since previous release, and the development never
 stopped, mainly thanks to Thorsten. See the 'ChangeLog' file for details.

 Tons of things have been fixed in all areas of the ARAnyM, and lots of
 new features have been added. Following list is incomplete but still gives
 you a good overview:

 Notable changes:
 ----------------
 * ARAnyM is hosted by GitHub.com at https://aranym.github.io/
 * there are automated builds for x86/amd64, armhf and macOS
 * added hotkey for turning audio on/off
 * HostFS MiNT file locking implemented
 * nfosmesa updated to OpenGL 4.6
 * MetaDOS driver improved
 * hotkeys work in the Setup GUI dialog as well
 * configurable directory for screenshots (via Setup GUI)
 * on macOS the configuration file is now looked up first
   in ~/Documents/Aranym_files (if it does not exist yet)
 * displaying non-ASCII characters in the fileselector
   should work now
 * path of loaded TOS/EmuTOS can now be selected in the Setup GUI
 * JIT CPU compiler now supports Solaris
 * JIT CPU compiler now supports more 64bit hosts (like kfreebsd)

 New features:
 -------------
 * NatFeat SCSI driver for Linux
 * NatFeat host exec
 * NatFeat for query/set CPU JIT
 * NatFeat for ARAnyM exit
 * new command line option --option
   that can set any value from the config file
 * AppImage can now be built


2014/10/17 - version 1.0.2 released
==========

 o typo error hopefully fixed


2014/10/17 - version 1.0.1 released
==========

 Just a quick bugfix release:

 o SDL NF CDROM is included in the build correctly
 o JIT is supported on kfreebsd (alternate kernel for Debian OS)
 o some warnings that prevented build on Debian fixed


2014/10/15 - version 1.0.0 released
==========

 Major highlights of this release:

 o JIT CPU compiler now supports also ARM platforms driven by Linux

 o JIT CPU compiler fixes memory management and adds some instructions

 o massive NatFeat HostFS fixes and improvements (symlinks and more)

 o NatFeat CD-ROM for Win32 and SDL

 o NatFeat OSMesa support improved (OpenGL 4.4 / Mesa 10.1.4)
   osmesa.ldg can replace tinygl.ldg now

 o seamless mouse integration and keyboard input improved

 o NVRAM: many country codes added (from current FreeMiNT)

 o libSDL2 is supported now (along with libSDL 1.2.x)

 o Cygwin, MinGW, Mac OS X, CentOS and Debian build fixes

Countless bug fixes and many other under-the-hood improvements are included
as well. This release crowns more than 13 years of continuous development
by many dedicated programmers (listed in the AUTHORS file). Thank you all!


2014/04/12 - version 0.9.16 released @ atariada.cz
==========

 Major highlights of this release:

 o JIT CPU compiler supported on 64-bit Linux and Mac OS X now!
   (Jens made a miracle)

 o MFPR FPU emulation should be perfect
   (Andreas ironed out few remainings bugs)

 o Ethernet support under Mac OS X should be way better
   (Philipp added support for big packets and multi-packets)

 o new config setting "LoadToFastRAM" to load kernel in FastRAM
   (is Andreas working on fixing Linux-m68k issues in FastRAM?)

 o David Gálvez improved NatFeat USB support (now requires FreeMiNT 1.19+)

 There's also a small set of bugs fixed in this release - mainly in Mac OS X
 thanks to Philipp but also some generic things like GPIP (Patrice).


2013/04/15 - version 0.9.15 released
==========

 The main new feature of this release is the seamless mouse integration mode:

 o Mouse input handling is improved a lot. Now ARAnyM has a seamless mouse
   integration when new Clocky (2013/04/15) is loaded.

 o There is no need to manually ungrab or grab the mouse.

 o Also mouse grab on left button click now reacts on the first button
   click everytime (previously only if you had window focus) and the
   host and mouse cursor positions are synced.

 o And if you ungrab the mouse intentionally then it's not automatically
   grabbed when the host mouse pointer returns to ARAnyM window.

 o At last, the annoying "resetting weird mouse packet" error is gone, too.

 Bugs fixed:

 o Native Features were missing proper memory overflow checks and bugs
   in NatFeat drivers could kill the ARAnyM.

 o NFVDI had a bug (a race condition) in resolution switching.

 o build date of EmuTOS was decoded improperly


2012/09/20 - version 0.9.14 released
==========

 Mac users: check out the new bridged ethernet (see README_ethernet.rtf).

 All users: try out the new Single Blit Composing and Single Blit Refresh
 modes - they might give you a better video performance.

 There are also many compilation and build fixes for various MacOSX targets
 and few MPFR FPU fixes.

 And last but not least, there's a neat user requested feature - mouse ungrab
 (frees your keyboard and mouse from ARAnyM window so you can work in other
 applications while ARAnyM is running) simply by clicking the host middle
 mouse button (well, works only if you don't have the Eiffel mouse wheel
 emulation enabled in settings).

 
2012/03/23 - version 0.9.13 released
==========

 A couple of important bugfixes accumulated in last few days:

   o USB NatFeat doesn't fail to claim devices in certain cases

   o MPFR FPU got fix for restarting of instructions after access error

   o JIT CPU version should work even when compiled with newer compilers

   o update your mmusetup.cnf in MiNT setup for larger FastRAM (see
     provided atari/mmusetup.cnf that is set for 512 MB FastRAM now)


2012/03/19 - version 0.9.12 released
==========

 New features:

   o MPFR based new precise FPU emulation core. Somewhat slower than the
     normally used IEEE or UAE FPU emulation cores (about 5 times)
     but should be totally complete and precise. Enabled in Linux binary
     MMU builds (aranym-mmu). Hopefully Debian-m68k developers will enjoy it
     :-)

   o USB NatFeat fully usable: https://github.com/aranym/aranym/wiki/manual#usb
     With a FreeMiNT driver you can access your USB flash discs from
     the Atari side easily. First enter the SETUP GUI and plug in
     the desired USB device. The USB support is compiled in by default
     in all linux binary packages.

   o NF Clipboard implemented newly for BeOS

   o "aranym --version" will now list the built-in FPU core and also all
     NatFeats that are compiled in.

 Bugfixes:

   o memleaks in various files
   o blitter memmove fix
   o MacOSX project fixes
   o small 64bit fixes in nfcdrom
   o aliasing issue fixes (in nfosmesa that is not compiled in)
   o CPU CAS+CAS2 instructions - several very important fixes!
   o some little fixes for newer GCCs in various files
   o RPM spec file updated for Fedora, openSUSE and Mandriva. Give
     rpmbuild -tb aranym_0.9.12.orig.tar.gz a try!


2011/02/06 - version 0.9.11 released
==========

 New features: SCC serial port emulation and USB NatFeat support.
 BeOS/Haiku port: fixes and improvements.
 MMU emulation: fix for initialization and FPU registers.
 Video: fix (refresh palette when switching from true color to bitplane
 mode) and an improvement (use current fullscreen size if fixed size is 0x0).


2010/05/27 - version 0.9.10 released
==========

 New feature: GEM clipboard support that allows you to pass data between
 GEM clipboard and the host one (MS Windows, Mac OS X and X Window System).
 It's currently implemented in FreeMiNT only and uses its aranym.xfs
 virtual filesystem (U:\host\clipbrd). Please see setup instructions
 in https://github.com/aranym/aranym/wiki/gem_clipbrd

 Also couple of important bugfixes:

 o fixed two nasty crashes in HostFS (related to recent symlink fixes)
 o fixed Xcode building universal binaries on PPC
 o VIDEL autozoom feature with correct aspect ratio for non-square pixels


2009/09/05 - version 0.9.9 released
==========

 This time mostly bugfixes:

 o fixed possible crash in HostFS when quitting ARAnyM (not serious)
 o fixed possible crash due to bug in libSDL up to v1.2.13 (very serious)
 o fixed some redrawing problems in 8 and 16 color depths with soft NfVDI
 o fixed all compile time warnings and Categories entry in aranym.desktop
 o fixed weirdness when mouse pointer was leaving the window on Win and OSX
 o fixed problem with invalid HostFS symlink breaking directory list
 o improvement: HostFS symlinks are now shown as relative if possible 
 o fixed indirect descriptors handling in MMU
 o fixed HostFS symlinks for certain path configurations
 o added Mode key in the set of ARAnyM hotkey modifiers
 o fixed Alt+mouse click problem on Mac OSX
 o fixed Right Shift detection upon startup

 If you found ARAnyM crashing previously when moving windows around
 or doing any other activity where VDI had to blit screen areas then
 please upgrade to this version ASAP. We've added a workaround for
 a serious bug in the libSDL that was causing these weird ARAnyM crashes.


2009/04/25 - version 0.9.8beta released
==========

 o CPU: fixed TRAPcc and FTRAPcc instructions (for Guillaume's mplayer :-)
 o VIDEL: pixel precise horizontal scrolling implemented
 o fixed BUSY signal handling on the parallel port
 o fixed mouse grab/ungrab/autograb (see below)
 o added new ARAnyM mouse cursor (white arrow)
 o added middle mouse button handling (in Eiffel mode)
 o added suport for reversing mouse Y-axis in IKBD (used in Linux-m68k)
 o fixed many DSP56001 instructions
 o fixed NFJPEG on 64bit hosts
 o fixed several NF drivers to work under FreeMiNT (not rely on __NF cookie)
 o buggy JIT-FPU was disabled. Now FPU is precise though slower in JIT mode

 Mouse grab/ungrab/autograb has changed: first, ungrabbing when leaving
 ARAnyM window was fixed (issue with autograb on the window border).
 Then, ARAnyM got a new mouse cursor (white one) so you can recognize
 now when the mouse is grabbed (the cursor pointer is black in TOS)
 and when it's not (the cursor pointer is white now).
 At last, mouse autograb upon entering ARAnyM window was disabled until
 we can ensure the Atari mouse cursor is positioned in sync with host
 mouse cursor (will require Atari OS support, probably in a form
 of aranym.acc and AES implementing appl_tplay).
 Also the "AutoGrabMouse" config option has been removed.


2008/11/08 - version 0.9.7beta released
==========

 Mostly small fixes at various places plus a lot of work went into
 improving the DSP56001 emulation. Also the sound DMA emulation is improved
 to a point where GSXB driver should be unnecessary.

 o improved automatic network setup on Mac
 o reworked audio DMA emulation. Also added configurable host sound frequency
 o one MMU bug fixed (regarding TTR)
 o special support for halting ARAnyM on linux-m68k reboot (--halt)
 o SDL GUI fixed (missing events after alerts)
 o EMULOP is now privileged so if some old ARAnyM TSR starts crashing this is why
 o joypads are now emulated
 o joysticks and joypads can be configured in the config file
 o '<>' and 'End' keys' scancodes made Atari compatible

 Check the doc/config example file for the new [JOYSTICKS] and [AUDIO] sections.


2008/01/29 - version 0.9.6beta2 released
==========
 
 Main change: major graphics output overhaul, two video backends - software
 and OpenGL renderer. Faster graphics output on all platforms. Try enabling
 the OpenGL output in the [OPENGL] section of the config file (beware, might
 not work on some platforms, tested on Linux only).

 Massive Mac OS X port improvements: MacIntel supported, fat binaries
 available, JIT working (on x86), networking working, and more.

 o IDE disks now up to 130 GB large (removed 32 GB barrier)
 o SCSI/partitions no longer limited to 2 GB, and made up to 4x faster
 o new ARAnyM logo at startup, new window manager, menu and desktop icons
 o networking fixes: now works after reboot, new Setup config dialog added
 o HostFS fixes: Dreadlabel() for MAGXDESK
 o SDL-GUI: 8x16 font, 80 columns, improved old dialogs and added new ones
 o MinGW compilable (native MS Windows binary, contrary to Cygwin one)
 o RTC timer on Linux host for more precise MFP timer interrupts
   (if it errors out try running "sudo sysctl -w dev.rtc.max-user-freq=1024")
 o new command line option "--locale CC" where CC is ISO country code
   (example: "--locale DE" will preset NVRAM to german keyboard layout)
 o one more FPU bug (visible in frexp()) fixed


2007/07/09 - version 0.9.5beta released
==========

 This version brings major speed up of the MMU version thanks to contribution
 of Roman Zippel and also many improvements for Mac OS X as well as bunch of
 smaller fixes at many places by dedicated ARAnyM developers.

 o OpenGL fixes: mouse cursor, alpha channel on big-endian machines
 o OpenGL is loaded dynamically now (requires SDL 1.2.10 or newer)
 o new project file for Xcode 2.x used to build Universal binaries of MacAranym
 o JITc for Solaris x86
 o MMU translation cache for major speed up of the MMU mode (now almost
   comparable with non-MMU mode - 3 GHz host CPU outperforms 100 MHz 68060!)
 o HostFS symlink fix
 o new TOS patches and VIDEO SETUP dialogs. Most of the settings require
   reboot to take effect.
 o VIDEL refresh was wrong, now fixed and configurable on-the-fly in SETUP
 o TV/VGA switch was wrong, now fixed and configurable in the SETUP
 o small CPU bitfield insn fix, FPU sin/cos fix, VIDEL ST-Shifter fix,
   nfVDI mfdb.fd_stand fix, TOS bconout redir fix...
 o many other build system fixes


2006/11/28 - version 0.9.4beta2 released
==========

 I was so wrong when I wrote "last MMU bugs were fixed" in previous release
 notes. This second beta release fixes several newly found CPU/FPU bugs that
 appeared when ARAnyM became actually used by Debian-m68k people.
 So the linux-m68k kernel as well as other MMU/FPU software should run
 much better now.

 Other news and fixes:

 o optional MIDI output to /dev/sequencer (in [MIDI] try Type=sequencer)

 o ARAnyM shouldn't hang on quit anymore

 o protect2k enabled by default (better HW compatibility with Atari)

 o cxx-exceptions enabled by default (considerably faster in MMU mode)

 o in Cygwin ARAnyM ignores $HOME and follows Windows practice with
   $HOME under Document and Settings/

 o new config file option "GMTime" (set to No by default). When enabled,
   ARAnyM uses Greenwich Mean Time (useful when running an OS that knows
   timezones like something Linux based or maybe even properly configured
   SpareMiNT)

 o linux-m68k properly boots now (with HW initialized)

 o IKBD settings (mouse wheel, AltGr) stored in [IKBD] section of ARAnyM
   config file

 o sound: preliminary locking (XBIOS LockSnd/UnlockSnd) implemented

 o nfVDI: fixed vswr_mode alpha expansions (tested on newsgroup reader Troll)

 o new option in [ETHx]: MAC = aa:bb:cc:dd:ee:ff for configuring the MAC
   Address of the network interface. You can run several ARAnyMs in a LAN
   now :-)

 For the additions in the ARAnyM config file see the provided commented
 configuration file.


2006/09/22 - version 0.9.4beta released
==========

 This release has one major highlight: two last MMU emulation bugs have
 been fixed and ARAnyM now runs Linux-m68k stable for days without any
 single issue. I can now fully recommend ARAnyM for Linux-m68k kernel
 development and also Debian-m68k development. Hoping that it will help
 the m68k linux platform to survive for a little longer.

 There is also a great new feature for those who are tired of setting up
 virtual disk drives for booting to TOS/GEM system: ARAnyM now supports
 bootstrapping directly from host filesystem! You need new versions of
 both EmuTOS and FreeMiNT kernel (with built-in HostFS driver) and
 the following configuration (in the [GLOBAL] section of ARAnyM config file):
   ------ aranym config --------
   Bootstrap = /path/to/mint.prg
   BootstrapArgs = DEBUG_LEVEL=1 BOOT_DELAY=0 MEM_PROT=NO 
   BootDrive = C 
   -----------------------------
 Of course you also need to define the BootDrive (C:) host path in the
 [HOSTFS] config section. FreeMiNT tries to locate the modules and other
 files in usual C:\MINT\ path that is redirected to your host filesystem.

 Other news and fixes:

 o new command line parameter -P (as in Position) will position the ARAnyM
   window to your desired location - enter the coordinates of upper left
   window corner ("-P 50,50") or try to center the window with "-P center".
   This should help especially on MS-Windows where the ARAnyM window often
   ended partially off screen.

 o Host desktop <-> AES clipboard interconnection. Currently for MS-Windows
   only. You need a special FreeMiNT driver that creates a new filesystem
   in FreeMiNT where you can point the AES to store the Clipboard. Find
   more information in documentation at https://github.com/aranym/aranym/wiki

 o various improvements in graphics area - major speed up for bitplane modes,
   speed up of graphics on Mac OS X, OpenGL alpha mask fix and others.

 o Mac OS X: Swapped meaning of CTRL and META key for Mac OS X back to
   "the logical way": The Apple key(s) represent left and right meta key
   and CTRL key is mapped to Atari CTRL key.
   A new, more Mac like set of keyboard shortcuts defined:
	Left Apple + , = Open preferences dialog
	Left Apple + q = Quit
	Left Apple + r = Reboot
	Left Apple + escape = Grab/Ungrab mouse cursor
	Left Apple + d = Enable debugger (if built-in)
	Left Apple + s = Save screenshot
	Left Apple + f = Toggle fullscreen mode

 o MS-Windows: corrected/improved window/fullscreen toggle.

 o bug #1521310 fixed: Shifters are now released before the GUI thread
   is started.

 o MIDI now outputs raw data which could be used for mapping the MIDI port
   to host MIDI directly (untested)

 o new compile-time configuration (--enable-protect2k) improves compatibility
   with ST/TT/Falcon where hardware protects first 2 kB of RAM against
   user mode accesses. Enabled by default in MMU build only since it can
   cause some performance degradation.


2006/02/20 - version 0.9.3beta released
==========

 Exciting news: ARAnyM now has its own domain (https://aranym.github.io/) and also
 brand new Wikiwiki for easier cooperation on improving ARAnyM documentation
 - visit https://github.com/aranym/aranym/wiki and look around...

 This is not much polished release. I have intended it mainly as a checkpoint
 for both developers and users, to resync and continue developing further.

 Eventhough most work went into into NF VDI since last release so ARAnyM can
 now output via OpenGL and features TrueType fonts (thanks to improved fVDI)
 there are many other changes in most areas of ARAnyM:

 o hotkey combination to free keyboard/mouse lock is LeftAlt+Ctrl+Shift
   (configurable in the SETUP GUI)
 o improved and bugfixed HostFS
 o fixed nfjpeg and enabled by default
 o nfosmesa with driver for FreeMiNT
 o switch to fullscreen and back works in MS Windows now
 o OpenGL NF VDI driver (almost?) working
 o configurable mouse cursor (ikbd or host)
 o configurable NF CDROM driver (linux or sdl)
 o configurable NF VDI driver (software or opengl)
 o joystick hat
 o DMA audio emulation
 o RTC timer for precise 200 Hz Timer C emulation
 o multiple ethernet interfaces (up to four in default build)
 o AltGr key (right Alt key on PC keyboard)
 o ethernet and floppy work in linux-m68k kernel
 o improved Mac OS X port
 o all binaries removed from source archive, to comply with Debian rules
   (don't distribute what you can't rebuild from the archive with supplied
   tools). There is a new AFROS CVS repository for the binary drivers.

 If upgrading from previous release you have to update the HostFS, NF VDI
 and also Ethernet drivers. We'll provide a ZIP archive with all necessary
 drivers. The impatient can get the Atari drivers at https://aranym.github.io//bin/

 
2005/04/14 - version 0.9.0 released
==========

 We've been providing 68040 PMMU (a memory management unit emulation,
 required for running FreeMiNT with MMU protection, and Linux/m68k)
 since version 0.1.5 (almost three years ago) though this is the first
 version of ARAnyM where the PMMU really works, thanks to awesome
 debugging and fixing done by Andreas Schwab.

 So ARAnyM runs Linux/m68k kernel now. Really. This opens up a new
 area of usage - ARAnyM can help developing Linux/m68k kernel and
 systems based on it (Debian/m68k, for example).

 Besides the PMMU there is a whole lot of new features and fixes:

 o multisession CD in IDE emulation
 o Win32 networking (TAP based, like in Linux)
 o NFOSMESA: OpenGL rendering for Atari applications using host CPU
 o NFJPEG: JPEG decoder (a TSR) using host CPU power via NatFeats, based
   on Brainstorm's JPEG DSP decoder API
 o direct disk partitions access
 o MFP interrupts fixed
 o LILO fixes, compiles without linux headers now
 o many 64-bit fixes and cleanups
 o compiling using the Fink suite on MacOSX
 o famous fVDI boot bug fixed
 o fVDI fixes in bitplanes
 o parallel port mapped to parport (in linux) or to a file
 o hotkeys configuration: Setup, Quit, Reboot, Ungrab, Debugger, ScreenShot
   and FullScreen hotkeys can be configured at runtime in the SETUP.
 o SETUP fileselector improved (folders before files, CWD)
 o fVDI pixel size bug fixed
 o documentation.txt updated with several new sections (networking,
   programming with ARAnyM, single partitions support and more).


2004/11/07 - version 0.8.11beta released
==========

 We've been slow and quiet lately but nevertheless a progress has been
 made. Some important changes for users include:

 o FASTRAM.PRG is no longer needed. Xavier patched TOS 4.04 so it now
   finds out the correct FastRAM size automagically.

 o Bridged networking works and is easy to set up thanks to the updated
   'arabridge' script and slightly improved documentation.txt.
   You must update your 'aranym.xif' FreeMiNT driver (now requires
   FreeMiNT 1.16.0 or newer) and also the nfeth-config tool.

 o JIT compiler in Windows binary works better than in previous release.

 o integrated LILO fixed (though ARAnyM does not boot Linux-m68k yet).

 o various little SETUP GUI improvements (edit fields are much better now,
   CHS values are updated correctly after creating new empty disk image,
   repeated saving of config file from the SETUP GUI fixed, new Keyboard
   and mouse setup dialog - almost empty now, but promising :-).

 o AutoZoom screen fixed and improved. You can now choose a constant host
   screen size for whatever the Atari screen size is. Might be very useful
   for LCD/DFP owners. This improvements required change in the API and so
   new version of 'aranym.sys' fVDI ARAnyM screen driver must be installed
   in your setup.

 o Mac users might enjoy new keyboard translation tables. All keys should
   be mapped correctly.

 o new EmuTOS included in this release fixes XaAES/FreeMiNT 1.16.1beta
   keyboard problems.

 o host mouse wheel can produce Eiffel 1.08+ compatible scancodes now.
   Switch this mode in the SETUP GUI. Note that currently neither fVDI
   nor EmuTOS support this.

 All beta testers (i.e. YOU :-) are encouraged to report all bugs
 and problems either into aranym user mailing list or directly into
 the bug tracker (available on ARAnyM webpages under the 'Contact' link).


2004/08/07 - version 0.8.10beta released
==========

 Great news for MS Windows users: ARAnyM runs with JIT CPU compiler now
 thanks to Xavier's work on sigsegv handler.

 Other than that we have been fixing bugs and cleaning the source code:

 o Francois fixed sinh and tanh (FPU instructions)
 o 'aratapif' is found in $PATH again
 o many more internal bug fixes that are not directly visible to users


2004/07/06 - version 0.8.9beta released
==========

 Great bug fixes:

 o JIT CPU is working on Linux 2.6.x
 o Blitter is finally not crashing anymore
 o integrated LILO (Linux Loader) reads gzipped files
 o SDL GUI now accepts numbers typed on numpad

 Especially the Blitter fix itself justifies a new release
 since it has always been buggy and it was so annoying. Now we've won.


2004/07/05 - version 0.8.8beta released
==========

 Main bug fixes:

 o MC68881 tan() insn fixed on ia-32 host cpu arch
 o one of JIT SIGSEGV crashes on linux 2.6.x
 o floppy emulation (corrupted in 0.8.6beta release)
 o HostFS fixes (symlinks, Dfree)
 o many MACOSX fixes (FPU works) and improvements
 o CapsLock under X11 fixed
 o various SDL GUI bugfixes

 New features:

 o new networking based on bridging:
   tools/arabridge is able to establish a bridge over the tap0 tunnel
   and eth0 nif so that aranym becomes part of your LAN visible from
   other machines etc. For example DHCP from ARAnyM works now.
   [ETH0] type = ppp|bridge and tunnel = tap0 config options added
 
 o Patrice's experimental PCI bridge (disabled in default builds), can
   be used for developing PCI drivers for Milan/Hades on ARAnyM :-)
 
 o SETUP GUI visually improved again (3D Look! :)

 o easy Disk Image generation in the SETUP - just enter your desired disk
   image path and size in MB and click on Generate.

 o configuration file parser now recognizes "~" special char that is
   expanded to $HOME (path to user home dir).


2004/02/15 - version 0.8.7beta released
==========

 o fixing HostFS bug that was introduced in 0.8.6beta
 o further visual improvements of SETUP GUI
 o better handling of Reset/Restart of an operating system


2004/02/08 - version 0.8.6beta released
==========

Important bugfixes, further SETUP improvements and new Mac OSX target:

 o visual improvements in SETUP GUI
 o new functions available in SETUP GUI (Fullscreen, ScreenShots, Help)
 o fixed changing path to Floppy in the SETUP
 o fixed serious bug in Floppy path configuration (crash at startup)
 o fixed serious bug in NVRAM handling (might caused crashes at early TOS boot)
 o hopefully fixed problem with HostFS mount points on aranym reboot


2004/01/07 - version 0.8.5beta released
==========

Number of important changes:

 o JIT CPU fixed! (although kernel 2.6 is not supported yet)
 o double bus errors (infamous error loops) handled now correctly
 o direct Mac OS X support for ARAnyM (compiles but doesn't run(?))
 o HostFS fixed
 o script for easy building of ARAnyM on Windows/cygwin 
 o SETUP GUI greatly improved - Disks Setup is complete, other will follow
 o SETUP GUI at startup of ARAnyM (-G command line switch)
 o floppy insert/eject support at runtime (in the SETUP GUI)
 o fVDI NatFeat driver with local color palette support (XaAES likes it)
   You will have to update your fVDI driver.
 o ARAnyM now defines new value for the _MCH cookie: 0x50000. Update
   your .aranym/config files with this new value.
 o Alt+Ctrl+Esc now helps releasing mouse&kbd input even in fullscreen

 New AFROS is released together with ARAnyM to provide the updated
 fVDI driver.

 Generally most work went into the SDL GUI SETUP which is becoming
 a central place for on-the-fly reconfiguration. Press the "Pause"
 key to open up the SETUP GUI anytime. Currently only disk configuration
 is complete but new setup dialogs will follow shortly.


2003/10/04 - version 0.8.2beta released
==========

Changes:

 o Direct Linux-m68k loading with integrated LILO
 o MIDI output to a file
 o HostFS cleaned up again (you must upgrade your HOSTFS.DOS driver)
 o SCSI emulation introduced which simplifies the harddisk driver
   installation greatly
 o STOP CPU instruction fixed to work properly (no more shaky
   mouse under EmuTOS and FreeMiNT)
 o Native access to host's CD/DVD-ROM using BetaDOS BOS NatFeat CDROM driver
 o Various little updates in README, FAQ and doc/documentation.txt
 o Literally tons of bugfixes and improvements (fVDI, JIT, XHDI, portability)


2003/04/11 - version 0.8.0beta3 released
==========

Changes:

 o Windows/Cygwin support greatly improved (see below)
 o HostFS bugfixed and works equally well on Windows/Cygwin

 Binaries released for Windows/Cygwin now define clearly where ARAnyM
 files are stored: User-specific files (configuration, NVRAM) are in
 subfolder ".aranym" in the My Documents folder (usually available from
 your desktop directly).  System-wide data (TOS, EmuTOS, font8.bmp) are
 stored in subfolder "aranym" relative to the aranym.exe binary.


2003/04/08 - version 0.8.0beta2 released
==========

Changes:

 o the key for making a screenshot changed to PrintScreen
 o [ARANYMFS] renamed to [HOSTFS]
 o aratapif execution fixed
 o HostFS improved
 o Cygwin support should be better

 For updating your ARAnyM config file simply run "aranym -s".


2003/03/23 - version 0.8.0beta1 released
==========

New features:

 o Networking. Yeah! ARAnyM.XIF as the Ethernet driver for MiNT-Net.
 o VIDEL compatible (bitplane) 1, 2, 4 and 8 bit fVDI modes.
 o new command line option "--swap-ide" that allows you to boot from [IDE1]
 o new HostFS drivers (both BetaDOS and MiNT's xfs) are fully working now.
 o for GFA programmers out there: natfeat/atari_example_gfa.lst
 o new config option "ModelName" for [IDE0/1]. Name your drives :-)
 o P4 fix for JIT (thanks to Gwenole of Basilisk II)
 o CD-ROM now also on Windows/Cygwin

 Naturally some bugs were fixed - most notably in mouse input.

 Also we've received some BeOS related patches so ARAnyM might run on BeOS
 as well now.


2003/01/29 - version 0.7.0 released
==========

What is new?

 NatFeats seem to finally stabilize. "__NF" cookie has been hardwired
 both to TOS 4.04 and to EmuTOS so it can be used by user applications
 to test for extended host capabilities. See the example code in
 src/natfeat/atari_example.c.

 Improved VIDEL emulation (virtual screens work now). Improved VIDEL
 rendering including auto zooming and OpenGL render.

 fVDI fixed. You must update your floppy/disk images with new fVDI driver.

 New experimental hostfs access drivers - instead of using MetaDOS driver
 under FreeMiNT Standa created a proper FreeMiNT XFS driver and then wrote
 a FreeMiNT API emulation layer for singleTOS' MetaDOS! This is untested
 so beware and backup your data first.

 Also more work has been done on ECE (Ethernet Card Emulation). It's
 unfinished, though - currently the MiNT driver throws bombs. We would
 need some Atari hackers to debug some of the Atari driver peculiarities.

 Large disks (disk images) supported now. There is also a new tool
 for creating real large disk images (up to 32 GB!)

 And as always, many bugfixes.

 I also put together a first snapshot of the "afros" (ARAnyM FRee OS" :-)
 Just download it, unpack it and run aranym with the provided config file.


2002/10/20 - version 0.6.8 released
==========

 Highlights:
 - aranym on Mac OS X really works
 - aranym can open read only disk drives or images (designed for aranym on CD)
 - CD-ROM works like on real Atari (auto mount)
 - GFA Basic works thanks to IKBD fix

 Finally an active Mac OS X user cared to send us a few mails so Mac OS X
 is now fully working and a binary package of aranym for Mac OS X will soon
 be available. Thanks Wim!

 The new option for read only disk drives has been extended so it's not
 XHDI specific anymore but works generally also for emulated IDE interface.
 Thus change your aranym config file - the XhdiWrite is replaced with
 ReadOnly flag.
 
 [IDE0|1]
 # XhdiWrite = Yes|No 		; default is No, enable for EmuTOS
 ReadOnly = Yes|No          ; default is No, change to Yes if you want
                            ; to open read only disk image (e.g. from a CD)

 Many various changes to JIT compiler (TuneAlignment, NOP filler and more).
 Several JIT related statistics are enabled in this build.

 CD-ROM support was greatly improved. CD Automount works like on real Atari,
 you just insert a CD and access it. For unmounting a CD you can either use
 various software utilities (try Ctrl+Shift+J in Thing!) or you can also
 use the aranym GUI - you'll find there new section "Discs" and in that 
 a CD-ROM button labelled either "Eject" or "Insert" (depends on the current
 CD-ROM status).

 Also an interesting fix in IKBD now allows GFA Basic (3.6TT) to run on
 Aranym (even under EmuTOS :)

 Some cosmetics changes - documentation updated mildly, aranym now prints
 its version on startup (include in your debug reports), some clean ups
 in the source code for better portability (non-c-headers support, generic
 bool..).


2002/10/12 - version 0.6.6 released
==========

 This release brings a couple of major changes. Probably the greatest is
 that the JIT (just-in-time) compiler of m68k code into x86 code works
 and makes ARAnyM the fastest Atari clone ever made. Now you can do things
 you never thought that would be possible - like watching fullscreen DivX
 movies or playing famous games like Quake. It's real fast.

 Another cool thing is the Native Features interface, designed to allow
 writing video/sound/disk drivers and other extensions in a portable way.
 First thing that got ported to NatFeat interface is the XHDI extension
 that lets EmuTOS access the ARAnyM disk drives directly. Other drivers
 will be ported to NatFeats soon. Look at src/natfeat/atari_example.c
 to see how easy is to write a NatFeat compliant driver.

 Surprising news is the DSP M56001 emulation that was added by Patrice.
 See what he has to say about it: "I only got one DSP program to work:
 a very simple rotozoom one I wrote. There are many things missing
 in the DSP emulation: interrupts, audio. The only programs that could
 work are those that use the DSP for calculations (and read/write their
 parameters on the host port). BadMood is in this case. You can also use
 the Motorola DSP tools to build DSP programs under Aranym, they work."

 Patrice also rewrote the IKBD/MIDI/ACIA implementation and ARAnyM now
 supports also joysticks. And improved VIDEL by adding auto center and
 auto zoom features (small Atari resolution should be zoomed automatically).

 New config options in aranym config file are as follows:

 [JIT]
 JIT = Yes|No
 JITFPU = Yes|No
 JITCacheSize = <amount_in_kB>	// cache size - bigger = better
 JITLazyFlush = <number>

 [IDE0|1]
 XhdiWrite = Yes|No 			// default is No, enable for EmuTOS

 Also, ndebug was improved. Breakpoints were added and also
 "run until <addr_in_memory> = <certain_value>" was implemented.

 fVDI blitting is faster now up to 4 times. Also, you have to update both
 fVDI.PRG and aranym.sys fVDI driver on your disk images. Don't forget that!

 For other fixes and changes please look into the ChangeLog file. Thanks.


 This is a list of unreleased versions and major changes in them:

2002/10/08 - version 0.6.5b - CPU back in main thread, SDL issues fixed

2002/09/28 - version 0.6.4b - Xhdi writing fixed. Backup your disk/images!

2002/09/28 - version 0.6.3b - bus error looping could be partially sorted out

2002/09/28 - version 0.6.2b - fVDI blitting accelerated, new IKBD/ACIA/joystick

2002/09/24 - version 0.6.1b - VIDEL zooming on dest screen

2002/09/15 - version 0.6.0b - SDL loop in main thread, CPU in separate thread

2002/09/12 - version 0.5.0b - CPU JIT compiler works thanks to 68040 TOS patch

2002/08/26 - version 0.4.0b - DSP runs in its own thread and is nearly complete

2002/08/04 - version 0.3.0b - Native Features implemented


2002/07/20 - version 0.2.0 released (celebrating the Woody release!)
==========

 Long time since previous release. I have been waiting for finishing
 a couple of promising modules but since Debian 3.0 (AKA Woody) has just
 been released I am releasing ARAnyM as well to celebrate it :-)
 Seriously, we wanted to give you something to play with and test the
 number of changes and new features in ARAnyM while we'll be working
 towards next major release.

 Major news:

   - new graphical user interface for runtime configuration of ARAnyM
     (unfinished yet)

   - EmuTOS being part of ARAnyM binary distribution (TOS 4.04 is not
     required to boot ARAnyM anymore)

   - boot floppy image with essential up-to-date ARAnyM drivers and tools
     (so you can easily upgrade your harddisk images)

 And now more detailed news in ARAnyM since last public release:

 Standa created 'fvdicout.app' which, being based on TosWin II source code
 should bring a complete VT52 emulation for applications with console
 output under fVDI. You'll find it in atari/fvdi/utility folder.

 Heiko Achilles added a 'mouse packet compressor' that is supposed to
 remove any delay when moving with mouse more quickly (or on more loaded
 machine). It may either fix problems you could have with your mouse
 or it can create a new, previously unseen mouse events' bugs. Test
 and let us know.

 The aranymfs (the MetaDOS host filesystem driver) has been converted
 to GCC compilable form. Please beware and test the host filesystem access
 carefully.

 Brand new keyboard hotkeys:

 - Scroll Lock (the mostly unused key on PC keyboards) now switches
   between windowed and fullscreen mode!

 - Ctrl+Pause cold reboots the ARAnyM correctly now

 - Pause key now invokes cool new ARAnyM GUI configuration.

 Please note that the GUI is far from being finished. The only useful
 option is the "Reset" and perhaps also the Quit (for those that can't
 remember the Shift+Pause combo). The GUI will soon be filled with tons
 of configure options so stay tuned...

 Another change from previous versions is that we now require original
 TOS 4.04. Various patched versions we supported before are unsupported
 now. So please get a clean original TOS 4.04 - or give the EmuTOS a try!
 All you need is to empty the "TOS=" option in the ARAnyM config file.

 Long filename->TOS 8.3 format conversion was improved so that it now
 handles also filenames ending with a dot.

 A long standing bug in Yamaha emulation was fixed. This helps mainly
 the lowlevel emulation of parallel port access. The parallel/printer
 port is emulated so accurately that even PARCP works flawlessly.
 Note though that this is not enabled automatically as it requires
 root privileges to run ARAnyM. We are going to add other methods
 for accessing the host parallel port in a more user/kernel friendly
 way.

 I know that after releasing the input focus with Alt+Ctrl+Esc combo
 sometimes the Alt+Ctrl stay held down. I added a special code for 
 removing the stale Alt+Ctrl state. Please let us know if this helped.

 Hackers Guide (hguide.txt) was updated. If you want to hack on ARAnyM
 you should read it first.

 From the other exciting news: Patrice Mandin has started work on DSP
 emulation for ARAnyM. He's actually nearly finished it so it may be
 available in the next version of ARAnyM already!

 Johan Klockars also started rewriting some pretty core things in the
 fVDI ARAnyM driver and fVDI itself so expect the next major release
 to be a real killer (in both good and bad sense ;-)

 BTW, if there is a developer that would be willing to finish the nearly
 working ECE (Ethernet Card Emulation) then please join us in ARAnyM
 development mailing list.

 Generally, there is a lot of cool things to work on in ARAnyM project
 so if you want to help out then write to us.


2002/04/22 - version 0.1.7 released
==========

 Sound is working! Put the atari/sound/zmagxsnd.prg to your AUTO
 folder and Aniplayer (after switching to XBIOS in its Sound Config
 dialog) should play all sounds nicely!

 Several very bad or annoying bugs in aranymfs fixed. Now it should
 be real usable.

 It's possible to Reboot the machine by pressing Ctrl+Pause.
 IKBD problems after reboot will be fixed in next release.

 Two new config file options: "Redir_Console" and "Redit_Printer".
 If set to "yes" the BIOS console (2 and 5) or printer (0) output
 is redirected to the host console.

 RPM spec file for ARAnyM. If your Linux distro is RPM based you may want
 to try out the following command:
    'rpm -tb aranym-0.1.7.tar.gz'
 It should build a binary RPM package of aranym which you can then install
 the usual way (rpm -i aranym*.rpm).


2002/04/12 - version 0.1.6 released
==========

 Serious problem with NMI not being able to break STOPped CPU
 fixed. Also when compiled with --disable-timer it now generates
 system 200 Hz interrupt correctly even when the CPU is STOPped.


2002/04/11 - version 0.1.5 released (please update your fVDI driver!)
==========

 Since the previous public release we made a lot of changes. Probably the most
 significant is the large rewrite of CPU. Current ARAnyM can be compiled
 with full PMMU (Memory Management Unit of Motorola 68040 CPU). This brings
 the ability to run FreeMiNT with memory protection enabled. It also opens
 door for running Unix-like operating systems (Linux or NetBSD for m68k)
 but unfortunately the current level of HW emulation is not sufficient for
 those yet. But we are working on it (and gladly accept any help from you!)

 While rewriting the CPU we also updated the FPU. ARAnyM's FPU now fully
 supports all MC68881/2 as well as MC86040 FPU instructions.
 
 There is also a developer version of ARAnyM with JIT (just-in-time compiler)
 but it is not stable enough yet.

 SGI/Irix is yet another supported host platform and we have added preliminary
 support for MiNT as the host platform ;-)

 On most supported host platforms the memory access was accelerated (thus
 the overall speed of ARAnyM increased).

 ARAnyM is the first Atari compatible platform with support for the native
 instruction interface (Native Features). That will bring new possibilities
 for next generation Atari software.

 AranymFS - our system clean MetaDOS driver for accessing host filesystem
 was greatly bugfixed. During debugging of this some Atari software proven
 to be ill-designed (such as PureC IDE - it is unable to cope with files
 on MetaDOS drives due to misusing certain range of GEMDOS handles. We
 developed a patch for it so now you can enjoy compiling with PureC on
 host filesystem). Besides that, there is a beta version of AranymFS.XFS
 driver for MiNT!

 The other improvements include new IDE emulation (including ATAPI CD-ROM,
 try e.g. ejecting the CD from within Thing desktop), new config file
 is created with correct default values, and many other fixes.

 Note that due to changes in fVDI host driver you need to update your
 fVDI Atari driver - there is a precompiled fvdi.sys in "atari/fvdi/drivers".
 Also you might want to update the AranymFS driver for MetaDOS/BetaDOS:
 it's also available as a precompiled binary in "atari/aranymfs/" folder.

 Last note: printing to Atari parallel port is now redirected to the console
 where you started ARAnyM from... This is not the final solution but rather
 a little hack that can be used for debug prints.


2002/02/12 - version 0.0.21 released
==========

 ARAnyM has a new version of IDE emulation. It should work on more
 platforms (*BSD, for example).

 Generally the portability is better (fixes also in ndebug and aranymfs).

 There is a new untested alpha version of aranym.xfs for MiNT.

 And we have a new long detailed users guide in documentation.txt file.


2002/01/28 - version 0.0.20 released
==========

 ARAnyM is at least +33% faster than the previous release. We greatly
 optimized the CPU memory access time and also interrupt emulation.

 ARAnyM runs with the SDL TimerThread by default again. This gives us
 more flexibility (see the STOP insn below) and is necessary for
 the upcoming JIT CPU (just-in-time compilation of m68k code).

 ARAnyM supports STOP instruction that put the CPU to sleep. This works
 perfectly in latest EmuTOS (CVS version). ARAnyM does not eat CPU
 cycles when the EmuTOS is idle.

 ARAnyM configuration file changed its location and got more options:
 all ARAnyM user files are now located in $HOME/.aranym/ folder.
 The configuration file is named "config" (thus the complete path is
 $HOME/.aranym/config). The configuration file is created automatically
 if it is not found. The old $HOME/.aranymrc is not read, you have to
 update your new config file by hand.

 New noteworthy command line options include "--refresh <x>" where you
 can specify the VIDEL refresh.

 ARAnyM now contains special support for native harddrive access from
 EmuTOS. This allows EmuTOS to actually boot from a harddrive attached
 to ARAnyM machine.

 Many many fixes - in floppy (formatting works), fVDI driver (colors after
 resolution change), NVRAM (year 2002 not 2001), MFP (TimerC) and more.

 Great thing for all Debian users - ARAnyM is now included in Debian Sid
 distribution.

 Last but not least - ARAnyM runs under Windows as well. You can compile
 the released source code with Cygwin to get Windows executable.

 Look into ChangeLog for more details.


2001/12/06 - version 0.0.11 released
==========
 The keyboard emulation in aranym has been rewritten and is based on pure
 scancodes now. Thanks to that the original TOS kbd tables should work on
 regular PC keyboards (at least English/USA works perfectly). You should be
 able to use any NVRAM configuration tool to switch your TOS kbd layout
 nationality from USA (now default) to any other of the six(teen) defined.
 Don't forget to update the Clocky.prg (current version available in
 src/atari/tools/ does not alter the original TOS keyboard by default).

 Previously there were errors when reading floppies with FastRAM enabled.
 Use the latest FastRAM v2.0 (available in src/atari/tools) and floppies
 will be OK - well, apart from those large floppies (4 MB and more) from
 STonX. These are NOT VALID floppies but rather single partitions of
 a harddrive. ARAnyM will handle them when we implement XHDI emulation.

 IKBD emulation was fixed so that Videlity config program works now. Videlity
 is a Falcon screen enhancer (freeware). Get it and enjoy Videl at 1024x768 :)

 fVDI was greatly improved so you might not need to play with Videlity at all.
 Use the new aranym.sys driver available in src/atari/fvdi/drivers/ and also
 the new fVDI.prg itself (src/atari/fvdi/).

 The patches for TOS 4.04 were cleaned up a lot. If you were using
 a prepatched TOS version please delete it and get the original TOS 4.04.

 IDE emulation was fixed so that formatting and partitioning of ext2 by
 a MiNT installer work now properly.

 Various bugfixes were done including ndebug, aranymfs, MMU040, command line
 parameters and more.

 If you want to debug aranym itself (in gdb) or to debug something inside
 of aranym using the internal debugger then you might want to disable the
 mouse grabbing completely: simply run aranym --nomouse (or -N).

 Last but not least - ARAnyM has been successfully ported to Solaris (with
 help of Francois LE COAT) and Windows/cygwin (thanks to Olivier Landemarre).


2001/11/06
==========
 The TOS patch we used included WinX by a mistake. That's been removed.
 Now you'll need to install real GEMRAM and also WinX to your auto folder
 if you wish to use the WinX AES enhancements. Please note that the
 GEMRAM 1.0 from the Aratools does not work. It actually didn't work for
 a long time. Use the real GEMRAM (that copies ROM to RAM) instead if you
 want to use WinX.


2001/11/01
==========

 Mouse behavior fixed:
  1) you can release mouse grab by pressing Alt+Ctrl+Esc (VMware compatible)
  2) you can grab mouse by click the left mouse button (VMware compatible)
  3) if the Atari mouse driver is active, you can release mouse by moving
     the mouse off the window and by moving back you grab it again. This
     can be disabled by setting "AutoGrabMouse=No" in the config file.

 You can save the config file by 'aranym -s' (or --save). This is useful
 if you want to see newly added options. You can also choose a different
 config file by 'aranym -c /path/to/different/aranymrc'. This even works
 together: 'aranym -c /tmp/aranymrc.example -s' will create a fresh config
 file in /tmp with all default values.


2001/10/29
==========
--rom removed
--floppy added

aranymrc.example updated

.aranymrc has a new option "EmuTOS" that holds a path to the EmuTOS.
When "EmuTOS=" is defined the "TOS=" is ignored (EmuTOS is the future! :)


2001/10/18
==========

Aranym is now able to work with the original TOS 4.04.


2001/10/02
==========
--ttram renamed to --fastram
-T renamed to -F
--grab_mouse and -g removed (mouse is always grabbed)

.aranymrc has a new option "cookie_MCH" that holds hex value.
Example: cookie_MCH = 0x3000 is for standard Falcon _MCH

Other details in src/ChangeLog
